class Prediction:
    def __init__(self, event, user, db):
        self.event = event
        self.owner = user
        self.bers = {}
        self.ders = {}
        self.closed = False
        self.total = 0
        self.finished = False
        self.db = db

    def close(self, user):
        if user != self.owner:
            return "not the owner."
        if self.closed:
            return "already closed."
        self.closed = True
        for believer in self.bers:
            amnt = min(self.bers[believer], self.db[believer]["coin"])
            self.bers[believer] = amnt
            self.db[believer]["coin"] -= amnt
            self.total += amnt
        for doubter in self.ders:
            amnt = min(self.ders[doubter], self.db[doubter]["coin"])
            self.ders[doubter] = amnt
            self.db[doubter]["coin"] -= amnt
            self.total += amnt
        return "Predictions closed!"

    # assumes amnt > 0
    def believe(self, user, amnt):
        userid = str(user.id)
        if self.closed:
            return "Predictions closed!"
        if self.db[userid]["coin"] < amnt:
            return "You're too poor, you can't afford that much."
        self.bers[userid] = amnt
        return "You are now **believing**! for **" + str(amnt) + "** nickcoin!"

    def doubt(self, user, amnt):
        userid = str(user.id)
        if self.closed:
            return "Predictions closed!"
        if self.db[userid]["coin"] < amnt:
            return "You're too poor, you can't afford that much."
        self.ders[userid] = amnt
        return "You are now **doubting**! for **" + str(amnt) + "** nickcoin!"

    def payout(self, user, who):
        if not self.closed:
            return "Predictions still open! **!close** to close predictions."
        if self.owner != user:
            return "not the owner."
        self.finished = True
        if who == "b":
            if not self.bers:
                return "NO ONE WON ANYTHING."
            btotal = sum(self.bers.values())
            for believer in self.bers:
                payout = int((self.bers[believer] * self.total) / btotal)
                self.db[believer]["coin"] += payout
            return "PAID OUT **" + str(self.total) + "** to the **BELIEVERS**!"
        else:
            if not self.ders:
                return "NO ONE WON ANYTHING."
            dtotal = sum(self.ders.values())
            for doubter in self.ders:
                payout = int((self.ders[doubter] * self.total) / dtotal)
                self.db[doubter]["coin"] += payout
            return "PAID OUT **" + str(self.total) + "** to the **DOUBTERS**!"

    def state(self):
        returner = self.event
        returner += "\n " + "BELIEVERS: "
        returner += str(self.getBersNames()) if self.bers else "None"
        returner += "\n " + "DOUBTERS: "
        returner += str(self.getDersNames()) if self.ders else "None"
        return "```" + returner + "```"

    def getBersNames(self):
        lst = []
        for key in self.bers.keys():
            lst.append(self.db[key]["name"])
        return lst

    def getDersNames(self):
        lst = []
        for key in self.ders.keys():
            lst.append(self.db[key]["name"])
        return lst
